import Promise from 'bluebird';

import { tsNow } from '../service/time-manager';
import { NetworkerThread } from '../service/networker/index';

var inited = false;

function _ref() {
  return Promise.resolve();
}

class LongPoll {

  constructor(thread) {
    this.maxWait = 25e3;
    this.pendingTime = -Infinity;
    this.isActive = true;

    this.thread = thread;
    if (inited) {
      console.log('!!!!!!!!!!!!!!!!!!!!!!!!!!! re init', thread);
      //$FlowIssue
      this.request = _ref;
    }
    inited = true;
  }

  setPendingTime() {
    this.pendingTime = tsNow() + this.maxWait;
  }
  request() {
    return this.thread.wrapMtpCall('http_wait', {
      max_delay: 500,
      wait_after: 150,
      max_wait: this.maxWait
    }, {
      noResponse: true,
      longPoll: true
    });
  }

  sendLongPool() {
    //TODO add base dc check
    if (!this.isActive) return Promise.resolve(false);
    this.setPendingTime();
    return this.request();
  }
}

export default LongPoll;
//# sourceMappingURL=long-poll.js.map