'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _timeManager = require('../service/time-manager');

var _index = require('../service/networker/index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var inited = false;

function _ref() {
  return _bluebird2.default.resolve();
}

class LongPoll {

  constructor(thread) {
    this.maxWait = 25e3;
    this.pendingTime = -Infinity;
    this.isActive = true;

    this.thread = thread;
    if (inited) {
      console.log('!!!!!!!!!!!!!!!!!!!!!!!!!!! re init', thread);
      //$FlowIssue
      this.request = _ref;
    }
    inited = true;
  }

  setPendingTime() {
    this.pendingTime = (0, _timeManager.tsNow)() + this.maxWait;
  }
  request() {
    return this.thread.wrapMtpCall('http_wait', {
      max_delay: 500,
      wait_after: 150,
      max_wait: this.maxWait
    }, {
      noResponse: true,
      longPoll: true
    });
  }

  sendLongPool() {
    //TODO add base dc check
    if (!this.isActive) return _bluebird2.default.resolve(false);
    this.setPendingTime();
    return this.request();
  }
}

exports.default = LongPoll;
//# sourceMappingURL=long-poll.js.map